﻿using UnityEngine;
using System.Collections;

public class CoinCounter : MonoBehaviour
{

	public Sprite[] spriteDigits;
	public int value = 0;
	public float spacing = 0.4f;
	private int displayValue = -1;

	// Use this for initialization
	void Start ()
	{

	}

	// Update is called once per frame
	void Update ()
	{
		// If the value has changed, we need to re-render our sprites
		if (displayValue != value)
		{
			// Turn our value into a string: 956 becomes "956"
			string digits = value.ToString();
			// Get any SpriteRenderer children
			SpriteRenderer[] renderers = GetComponentsInChildren<SpriteRenderer>();
			// Count how many we have
			int numRenderers = renderers.Length;

			// If we don't have enough SpriteRenders (one for each 'place' of our value), add them
			if(numRenderers < digits.Length)
			{
				// Keeping adding until we have enough
				while(numRenderers < digits.Length)
				{
					// Create a new empty game object
					GameObject spr = new GameObject();
					// Add a sprite render component
					spr.AddComponent<SpriteRenderer>();
					// Set this new game object to be a child of our current object
					spr.transform.parent = transform;
					// Set it's position so we can line up the 1s next to the 10s next to the 100s, etc
					spr.transform.position = new Vector3(numRenderers * spacing, 0.0f, 0.0f);

					// Increment how many renderers we have so the loop doesn't execute forever
					numRenderers++;
				}

					// Refresh our list of renderers
					renderers = GetComponentsInChildren<SpriteRenderer>();
			}

			// If we have two many reneders (e.g, 4 when we only have a 3 digit number) hide them
			else if(numRenderers > digits.Length) 
			{
				// While we have too many renderers
				while(numRenderers > digits.Length) 
				{
					// Clear their sprites
					renderers[numRenderers-1].sprite = null;
					// Decrement how many renderers we have so the loop doesn't execute forever
					// Note: this doesn't actually remove the renderer
					numRenderers--;
				}
			}

			// Set the sprite for each rendererd based on our value
			int rendererIndex = 0;
			foreach(char digit in digits) 
			{
				// Convert the char digit into an int which will be the index
				int spriteIndex = int.Parse(digit.ToString());
				// Update the proper renderer (starting at 0 which is the far left)
				// Set its sprite to be the proper sprite from our spriteDigits array
				// Because index 0 of spriteDigits is the sprite "0" and 1 is "1", this works
				renderers[rendererIndex].sprite = spriteDigits[spriteIndex];

				// Icnrement the rendererIndex so the next digit in our number displays on the proper renderer
				rendererIndex++;
			}
			displayValue = value;
		}
	}
}